package com.iflytek.cloud;

import android.content.Context;

import com.iflytek.cloud.msc.module.SpeechModule;
import com.iflytek.cloud.msc.msp.MscCommon;
import com.iflytek.cloud.msc.util.log.DebugLog;
/**
 * <h3>数据下载类</h3>
 * <p>
 * 		下载应用已保存在服务器的的个性化数据。
 * </p>
 * <p>
 * 		使用此类任何接口前，需要先调用{@link SpeechUtility#createUtility }
 * 进行SDK初始化。
 * </p>
 * 
 * @deprecated 此类已不再支持，个性化数据已不再支持下载，关于声纹密码的获取，请参
 * 				考{@link SpeakerVerifier#getPasswordList(SpeechListener)}。
 * @since version:1073
 * @author <script>gShowAuthor();</script>
 * @see SpeechUtility
 * @see DataUploader
 */
public class DataDownloader extends SpeechModule{
	
	/**
	 * <h4>构造函数</h4>
	 */
	public DataDownloader(Context context) {
		super(context);
	}
	
	/**
	 * <h4>数据下载</h4>
	 * @param listener 设置监听器, 通过监听类的函数回调，获取下载的数据
	 * @return 是否成功开始下载，若返回{@link ErrorCode#SUCCESS}则是，否则开始下载失败。
	 * @see SpeechListener
	 */
	public int downloadData(SpeechListener listener) {
		int ret = ErrorCode.SUCCESS;
		
		try{
			mscer = new MscCommon(mContext,mSessionParams,getHandlerThread( "download" ));
			((MscCommon)mscer).startDownload(new InnerSpeechListener(listener));
		}catch(SpeechError e){
			ret = e.getErrorCode();
			DebugLog.LogE( e );
		}catch( Throwable e ){
			ret = ErrorCode.ERROR_UNKNOWN;
			DebugLog.LogE( e );
		}//end of try-catch
		
		return ret;
	}
	
	@Override
	protected boolean onFini() {
		return true;
	}
}
