package com.iflytek.cloud;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * <h4>评测结果类</h4>
 * <p>
 * 		关于评测结果的各键值说明，请参考《Speech Evaluation API Documents》。
 * </p>
 * 
 * @author <script>gShowAuthor();</script>
 * @since version:1073
 * 
 * @see EvaluatorListener#onResult(EvaluatorResult, boolean)
 * @see SpeechEvaluator
 */
public class EvaluatorResult implements Parcelable {

	/**
	 * 评测结果，请参考文档中评测结果定义。
	 */
	private String mResult = "";

	
	private EvaluatorResult(Parcel in) {
		mResult = in.readString();
	}

	/**
	 * <h4>构造函数</h4>
	 * <p>
	 * 		应用层一般只用到{@link EvaluatorListener#onResult}返回的评测结果对象，
	 * 可忽略此构造函数。
	 * </p>
	 */
	public EvaluatorResult(String result) {
		if (null != result) {
			mResult = result;
		}
	}


	/**
	 * <h4>获取评测结果</h4>
	 * <p>
	 * 		获取xml格式的{@link java.lang.String}字符串，请参考《Speech Evaluation API Documents》。
	 * </p>
	 * 
	 * @return 评测结果
	 */
	public String getResultString() {
		return mResult;
	}
	
	@Override
	public int describeContents() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeString(mResult);
	}
	
	public static final Parcelable.Creator<EvaluatorResult> CREATOR = new Parcelable.Creator<EvaluatorResult>() {

		@Override
		public EvaluatorResult createFromParcel(Parcel in) {
			return new EvaluatorResult(in);
		}

		@Override
		public EvaluatorResult[] newArray(int size) {
			return new EvaluatorResult[size];
		}
	};
}
