package com.iflytek.cloud.msc.tts;

import java.util.ArrayList;

import com.iflytek.cloud.SpeechError;

/**
 * 合成监听器
 * @author iFlytek &nbsp;&nbsp;&nbsp;<a href="http://www.xfyun.cn/">讯飞语音云</a>
 * 
 */
public abstract interface MscSynthesizerListener {
	/**
	 * 缓冲进度
	 * @param datas 二进制数据
	 * @param progress 百分比
	 * @param beginPos 开始位置
	 * @param endPos 结束位置
	 * @param spellInfo 信息
	 * @throws SpeechError 
	 */
	void onBufferProgress(ArrayList<byte[]> datas, int progress,int beginPos,int endPos, String spellInfo) throws SpeechError;
	/**
	 * 结束回调,会话完成时调用
	 * @param error 错误类型
	 */
	void onCompleted(SpeechError error);
}
