package com.iflytek.cloud.msc.util.http;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;
import java.util.Random;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

//import org.apache.http.HttpHost;
//import org.apache.http.auth.UsernamePasswordCredentials;

import android.content.Context;
import android.net.Uri;
import android.os.SystemClock;
import android.text.TextUtils;
import android.webkit.MimeTypeMap;

import com.iflytek.cloud.ErrorCode;
import com.iflytek.cloud.msc.util.HttpRequest;
import com.iflytek.cloud.msc.util.SDCardHelper;
import com.iflytek.cloud.msc.util.log.DebugLog;

/**
 * @deprecated 弃用
 */
public class HttpDownloadImpl implements HttpTransListener {

	private static final int DEFAULT_BUFFER_SIZE = 4096;

	private static final String DEFAULT_DL_FILENAME = "downloadfile";

	/** 每次回调给上层进度改变的最小时间间隔 ，比40更小时间人眼也反应不过来？*/
	private static final int MIN_PROGRESS_CALLBACK_TIME = 40;

	/** The default extension for html files if we can't get one at the HTTP level */
	private static final String DEFAULT_DL_HTML_EXTENSION = ".html";

	/** The default extension for text files if we can't get one at the HTTP level */
	private static final String DEFAULT_DL_TEXT_EXTENSION = ".txt";

	/** The default extension for binary files if we can't get one at the HTTP level */
	private static final String DEFAULT_DL_BINARY_EXTENSION = ".bin";

	/** 下载临时文件后缀 */
	private static final String DOWNLOAD_TEMP_EXTENSION = ".tmp";

	/**
	 * When a number has to be appended to the filename, this string is used to separate the base filename from the
	 * sequence number
	 */
	private static final String FILENAME_SEQUENCE_SEPARATOR = "-";

	/** Regex used to parse content-disposition headers */
	private static final Pattern CONTENT_DISPOSITION_PATTERN = Pattern
			.compile("attachment;\\s*filename\\s*=\\s*\"([^\"]*)\"");

	private static Random sRandom = new Random(SystemClock.uptimeMillis());

	/**
	 * request id
	 */
	private long mId;

	/**
	 * request type
	 */
	private int mType;

	private HttpDownloadListener mListener;

	private boolean mCancel;

	//private HttpClients mHttpClients;
	private HttpRequest request;

	private long mBytesRead;

	private long mBytesTotal;

	private String mSpecifiedPath;

	private String mFilename;

	/**
	 * 是否覆盖重名的文件
	 */
	private boolean mCover;

	/**
	 * 文件后缀
	 */
	private String mExtension;

	private String mFileDir;

	private FileOutputStream mDownloadFileStream;

	/**
	 * 上次进度回调的时间
	 */
	private long mLastTimeChangeProgress;

	private long mMinBytesStepToChangeProgress;

	private long mLastBytesReadWhenChangeProgress;
	
	/**
	 * 上下文环境
	 */
	private Context mContext;

	public HttpDownloadImpl() {
		this(System.currentTimeMillis(), 0, null);
	}

	public HttpDownloadImpl(int type, Context context) {
		this(System.currentTimeMillis(), 0, context);
		mContext=context;
	}

	public HttpDownloadImpl(long id, int type, Context context) {
		mId = id;
		mType = type;
		mContext=context;
		//mHttpClients = new HttpClients(this);
		request = new HttpRequest();

	}

    public void setHttpDownloadListener(HttpDownloadListener listener) {
		mListener = listener;
	}

    public void start(String url, String currentPath, String specifiedPath, boolean cover, String eTag) {
		DebugLog.LogS("currentPath : " + currentPath + ", specifiedPath : " + specifiedPath + ", url : " + url);
		long offset = 0;
		mFilename = null;
		
		String filename;
		if (currentPath != null) {
			filename = currentPath;
		} else {
			filename = specifiedPath;
		}
		mSpecifiedPath = specifiedPath;
		mCover = cover;
		
		File downloadFile = new File(filename);
		if (downloadFile.exists()) {
			if (downloadFile.isDirectory()) {
				mFileDir = filename;
				mCover = false;
			} else {
				mFileDir = downloadFile.getParentFile().getAbsolutePath();

				if (currentPath != null) {
					// 如果已经下载了一半的文件以及存在，则从文件当前长度后接着下载
					offset = downloadFile.length();
					mFilename = filename;
				}
			}
		} else {
			if (filename.endsWith(File.separator)) {
				mFileDir = filename;
				mCover = false;
			} else {
				mFileDir = filename.substring(0, filename.lastIndexOf(File.separator));
			}
		}

		mBytesRead = offset;
		
		DebugLog.LogS("mFileDir : " + mFileDir + ", mBytesRead : " + mBytesRead + ", mSpecifiedPath : " + mSpecifiedPath);
		//mHttpClients.get(url, offset, eTag, DEFAULT_BUFFER_SIZE);
		request.setRequest(url,null,null);
		request.run();

	}

    /*public void post(String url, byte[] data, String savePath, boolean cover) {
    	DebugLog.LogS("specifiedPath : " + savePath + ", url : " + url);
//		mErrorDetail = null;
		long offset = 0;
		mFilename = null;

		String filePath;
		mSpecifiedPath = savePath;
		filePath = savePath;

		File downloadFile = new File(filePath);
		if (downloadFile.exists()) {
			if (downloadFile.isDirectory()) {
				mFileDir = filePath;
			} else {
				mFileDir = downloadFile.getParentFile().getAbsolutePath();
			}
		} else {
			if (filePath.endsWith(File.separator)) {
				mFileDir = filePath;
			} else {
				mFileDir = filePath.substring(0, filePath.lastIndexOf(File.separator));
			}
		}

		mCover = cover;

		mBytesRead = offset;
		mHttpClients.post(url, data, DEFAULT_BUFFER_SIZE);
	}*/
	
    public synchronized void cancel() {
		mCancel = true;
		//mHttpClients.cancel();
		request.cancel();
		
		if(!TextUtils.isEmpty(mFilename)){
			// 则先删除同名文件
			File finalFile = new File(mFilename);
			if (finalFile.exists()) {
				finalFile.delete();
			}
		}
		closeDownloadFileStream();
	}

    public long getId() {
		return mId;
	}
//
//	/**
//	 * check whether the filename is valid
//	 * @param filename
//	 * @return
//	 */
//	private boolean isFilenameValid(String filename) {
//		if (filename != null) {
//			return filename.startsWith(Environment.getExternalStorageDirectory().getAbsolutePath());
//		}
//		return false;
//	}

	/**
	 * Parse the Content-Disposition HTTP Header. The format of the header is defined here:
	 * http://www.w3.org/Protocols/rfc2616/rfc2616-sec19.html This header provides a filename for content that is going
	 * to be downloaded to the file system. We only support the attachment type.
	 */
	private static String parseContentDisposition(String contentDisposition) {
		try {
			Matcher m = CONTENT_DISPOSITION_PATTERN.matcher(contentDisposition);
			if (m.find()) {
				return m.group(1);
			}
		} catch (IllegalStateException ex) {
			// This function is defined as returning null when it can't parse
			// the header
		}
		return null;
	}

	/**
	 * Creates a filename (where the file should be saved) from a uri.
	 * 
	 * @param fileDir
	 * @param url
	 * @param contentDisposition
	 * @param contentLocation
	 * @param mimeType
	 * @param tempExtension
	 * @return [filename not contain extension, extension]
	 */
	private static String[] generateSaveFile(String fileDir, String url, String contentDisposition,
			String contentLocation, String mimeType, String tempExtension) {
		String filename = chooseFilename(url, contentDisposition, contentLocation);

		// Split filename between base and extension
		// Add an extension if filename does not have one
		String extension = null;
		int dotIndex = filename.lastIndexOf('.');
		if (dotIndex < 0) {
			extension = chooseExtensionFromMimeType(mimeType, true);
		} else {
			extension = chooseExtensionFromFilename(mimeType, filename, dotIndex);
			filename = filename.substring(0, dotIndex);
		}

		if (!fileDir.endsWith(File.separator)) {
			fileDir += File.separator;
		}
		filename = fileDir + filename;

		/*
		 * Generate a unique filename, create the file, return it.
		 */
		String realFileName = chooseUniqueFilename(filename, extension, tempExtension);
		return new String[] { realFileName, extension };
	}

	private static String chooseFilename(String url, String contentDisposition, String contentLocation) {
		String filename = null;

		// If we couldn't do anything with the hint, move toward the content
		// disposition
		if (filename == null && contentDisposition != null) {
			filename = parseContentDisposition(contentDisposition);
			if (filename != null) {
				int index = filename.lastIndexOf('/') + 1;
				if (index > 0) {
					filename = filename.substring(index);
				}
			}
		}

		// If we still have nothing at this point, try the content location
		if (filename == null && contentLocation != null) {
			String decodedContentLocation = Uri.decode(contentLocation);
			if (decodedContentLocation != null && !decodedContentLocation.endsWith("/")
					&& decodedContentLocation.indexOf('?') < 0) {
				int index = decodedContentLocation.lastIndexOf('/') + 1;
				if (index > 0) {
					filename = decodedContentLocation.substring(index);
				} else {
					filename = decodedContentLocation;
				}
			}
		}

		// If all the other http-related approaches failed, use the plain uri
		if (filename == null) {
			String decodedUrl = Uri.decode(url);
			if (decodedUrl != null && !decodedUrl.endsWith("/") && decodedUrl.indexOf('?') < 0) {
				int index = decodedUrl.lastIndexOf('/') + 1;
				if (index > 0) {
					filename = decodedUrl.substring(index);
				}
			}
		}

		// Finally, if couldn't get filename from URI, get a generic filename
		if (filename == null) {
			filename = DEFAULT_DL_FILENAME;
		}

		filename = filename.replaceAll("[^a-zA-Z0-9\\.\\-_]+", "_");

		return filename;
	}

	private static String chooseExtensionFromMimeType(String mimeType, boolean useDefaults) {
		String extension = null;
		if (mimeType != null) {
			extension = MimeTypeMap.getSingleton().getExtensionFromMimeType(mimeType);
			if (extension != null) {
				extension = "." + extension;
			} else {
			}
		}
		if (extension == null) {
			if (mimeType != null && mimeType.toLowerCase().startsWith("text/")) {
				if (mimeType.equalsIgnoreCase("text/html")) {
					extension = DEFAULT_DL_HTML_EXTENSION;
				} else if (useDefaults) {
					extension = DEFAULT_DL_TEXT_EXTENSION;
				}
			} else if (useDefaults) {
				extension = DEFAULT_DL_BINARY_EXTENSION;
			}
		}
		return extension;
	}

	private static String chooseExtensionFromFilename(String mimeType, String filename, int dotIndex) {
		String extension = null;
		if (mimeType != null) {
			// Compare the last segment of the extension against the mime type.
			// If there's a mismatch, discard the entire extension.
			int lastDotIndex = filename.lastIndexOf('.');
			String typeFromExt = MimeTypeMap.getSingleton().getMimeTypeFromExtension(
					filename.substring(lastDotIndex + 1));
			if (typeFromExt == null || !typeFromExt.equalsIgnoreCase(mimeType)) {
				extension = chooseExtensionFromMimeType(mimeType, false);
			}
		}
		if (extension == null) {
			extension = filename.substring(dotIndex);
		}
		return extension;
	}

	private static String chooseUniqueFilename(String filename, String extension, String tmpExtension) {
		String fullFilename = filename + extension;
		String fullTmpFileName = filename + tmpExtension;
		if (!new File(fullFilename).exists() && !new File(fullTmpFileName).exists()) {
			return filename;
		}
		filename = filename + FILENAME_SEQUENCE_SEPARATOR;
		/*
		 * This number is used to generate partially randomized filenames to avoid collisions. It starts at 1. The next
		 * 9 iterations increment it by 1 at a time (up to 10). The next 9 iterations increment it by 1 to 10 (random)
		 * at a time. The next 9 iterations increment it by 1 to 100 (random) at a time. ... Up to the point where it
		 * increases by 100000000 at a time. (the maximum value that can be reached is 1000000000) As soon as a number
		 * is reached that generates a filename that doesn't exist, that filename is used. If the filename coming in is
		 * [base].[ext], the generated filenames are [base]-[sequence].[ext].
		 */
		int sequence = 1;
		for (int magnitude = 1; magnitude < 1000000000; magnitude *= 10) {
			for (int iteration = 0; iteration < 9; ++iteration) {
				String realFileName = filename + sequence;
				fullFilename = realFileName + extension;
				fullTmpFileName = realFileName + tmpExtension;
				if (!new File(fullFilename).exists() && !new File(fullTmpFileName).exists()) {
					return realFileName;
				}
				sequence += sRandom.nextInt(magnitude) + 1;
			}
		}
		return null;
	}

	/**
	 * close the download file output stream
	 */
	private void closeDownloadFileStream() {
		if (mDownloadFileStream != null) {
			try {
				mDownloadFileStream.close();
			} catch (IOException e) {
				
			}
			mDownloadFileStream = null;
		}
		mFilename = null;
	}

	@Override
	public int onStart(long length, String mimeType, String newUrl, String eTag, String contentDisposition,
			String contentLocation) {
		DebugLog.LogS("onStart, url = " + newUrl);
		if (mCancel) {
			return -2;
		}
		String[] filename = generateSaveFile(mFileDir, newUrl, contentDisposition, contentLocation, mimeType,
				DOWNLOAD_TEMP_EXTENSION);
		if (mFilename == null) {
			// 获取保存的文件名
			mFilename = filename[0];
			if (mFilename == null) {
				// onError(HttpErrorCode.FILE_CREATE_FAILED, "file name is null");
				// cancel();
//				mErrorDetail = "file name is null";
				return ErrorCode.ERROR_FILE_ACCESS;
			}
			// 下载临时文件后缀
			mFilename = mFilename.concat(DOWNLOAD_TEMP_EXTENSION);
		}

		// 文件真实的后缀名
		mExtension = filename[1];

		DebugLog.LogS("onStart, bytesRead : " + mBytesRead + ", length : " + length);
		DebugLog.LogS("onStart, filename : " + mFilename + ", extension : " + mExtension);

		long availableSpace=0;
		//判断是否存在SD卡
		if(SDCardHelper.checkSDCardStatus()){
			availableSpace = SDCardHelper.getAvailableSpace(SDCardHelper.getExternalStorageDirectory());
		}else{
			availableSpace = SDCardHelper.getAvaliableMemSpace(mContext);
		}
		
		if (availableSpace < length - mBytesRead) {
			return ErrorCode.ERROR_FILE_ACCESS;
		}

		File parentDir = new File(mFileDir);
		if (!parentDir.exists()) {
			// 建立下载路径目录
			parentDir.mkdirs();
		}

		if (mCancel) {
			return -2;
		}
		DebugLog.LogS("create file success");
		try {
			mBytesTotal = length;
			mMinBytesStepToChangeProgress = mBytesTotal / 100;
			mLastTimeChangeProgress = SystemClock.elapsedRealtime();
            //mLastPercent = 0;
			mLastBytesReadWhenChangeProgress = 0;
			mDownloadFileStream = new FileOutputStream(mFilename, true);

			if (mCancel) {
				return -2;
			}
			if (mListener != null) {
				mListener.onStart(length, mimeType, mFilename, eTag, this);
			}
		} catch (FileNotFoundException e) {
			DebugLog.LogE("onStart, create file error", e.toString());
			return ErrorCode.ERROR_FILE_ACCESS;
		}
		return 0;
	}
	
	@Override
	public int onBuffer(byte[] data, int size) {
		if (mCancel) {
			return -2;
		}
		int errorCode = 0;
		try {
			mDownloadFileStream.write(data, 0, size);
			if (mCancel) {
				return -2;
			}
			mDownloadFileStream.flush();
			if (mCancel) {
				return -2;
			}
			mBytesRead += size;
			
			// 在时间和长度都满足条件时才回调
			if (mListener != null){				
				if (mBytesRead - mLastBytesReadWhenChangeProgress >= mMinBytesStepToChangeProgress){
					long currentTime = SystemClock.elapsedRealtime();
					if (currentTime - mLastTimeChangeProgress >= MIN_PROGRESS_CALLBACK_TIME){
						int percent = (int) (mBytesRead * 100 / mBytesTotal);
						mListener.onProgress(mBytesRead, percent, this);
						mLastBytesReadWhenChangeProgress = mBytesRead;
						mLastTimeChangeProgress = currentTime;
					}
				}				
			}
		} catch (IOException e) {
			return ErrorCode.ERROR_FILE_ACCESS;
		}
		return errorCode;
	}

	@Override
	public void onFinish() {
		DebugLog.LogS("onFinish | cover = " + mCover + 
	            " mFilename = " + mFilename + " mSpecifiedPath = " + mSpecifiedPath);
		try {
			// 下载完成，将临时文件重命名为最终的名称
			String finalFileName;
			if (mCover) {
				// 如果覆盖
				finalFileName = mSpecifiedPath;
			} else {
				// 否则直接替换后缀
				finalFileName = mFilename.substring(0, mFilename.lastIndexOf('.')).concat(mExtension);
			}
			
			// 则先删除同名文件
			File finalFile = new File(finalFileName);
			if (finalFile.exists()) {
				finalFile.delete();
			}

			// 再重命名
			new File(mFilename).renameTo(finalFile);

			if (!mCancel && mListener != null) {
				mListener.onFinish(finalFileName, this);
			}
			closeDownloadFileStream();
		} catch (Exception e) {
			e.printStackTrace();
			onError(20014);
		}
	}

	@Override
	public void onError(int errorCode) {
		DebugLog.LogE("onError errorCode = " + errorCode);
		if (!mCancel && mListener != null) {
			mListener.onError(errorCode, this);
		}
		closeDownloadFileStream();
	}

	/*public void setProxy(HttpHost host) {
		mHttpClients.setProxy(host);
	}*/

	/*public void setCredentials(UsernamePasswordCredentials credentials) {
		mHttpClients.setCredentials(credentials);
	}*/

	public int getType() {
		return mType;
	}

	@Override
	public void onCancel() {
		DebugLog.LogD("onCancel");
		closeDownloadFileStream();
	}
}
