package com.iflytek.cloud.param;

import android.os.Environment;

import com.iflytek.cloud.SpeechConstant;

public class MscKeys {
	public static final String SERVER_URL = "server_url";
	// APPID MD5信息
	public static final String MD5 = "appid_key";
	
	// 网络协议类型，用以判断EDGE、HSDPA、CDMA-EvDo rev.A等网络
	public static final String NET_SUBTYPE = "net_subtype";

	
	/** 获取基站相关信息：mmlc = MCC|MNC|LAC|CID
	 *  MCC，Mobile Country Code，移动国家代码（中国的为460）；
	 *	MNC，Mobile Network Code，移动网络号码（中国移动为0，中国联通为1，中国电信为2）； 
	 *  LAC，Location Area Code，位置区域码；
	 *	CID，Cell Identity，基站编号；*/
	public static final String MMLC = "mmlc";
	
	/**
	 * 会话模式<br>
	 * 当ssm=0或false的时候为非会话模式，当ssm=1或true的时候为会话模式。
	 */
	public static final String MSP_SSM = "ssm";
	
    /////////////////////////////////////日志保存,录音保存/////////////////////////////////////
	/** 
	 * 日志保存路径
	 */
	public static final String KEY_LOG_PATH = "log";
	
	/**
	 * 日志保存级别
	 */
	public static final String KEY_LOG_LEVEL = "lvl";
	
	/**
	 * 是否保存日志<br>
	 * 0是不保存控件 LOGCAT相关日志；1是保存LOGCAT和MSC日志；2是保存LOGCAT日志，同时将MSC日志输出到控制台显示；
	 * 3是保存LOGCAT和MSC日志，同时将MSC日志输出到控制台显示.
	 * 
	 */
	public static final String KEY_LOG_OUTPUT = "output";
	
	// 用户名
	public static final String USR = "usr";
	// 密码
	public static final String PWD = "pwd";
	
	// 设备号，IMSI|IMEI
	public static final String DVC = "dvc";
	
	// 设备Unique ID
	public static final String UNIQUE_ID = "unique_id";
	
	// 登陆认证，默认为true
	public static final String MSP_AUTH = "auth";

	// 音频采样率，如audio/L16;rate=16000
	public static final String AUDIO_AUF = "auf=audio/L16;rate";
	
	// 音频编码,如aue=speex-wb;7
	public static final String AUDIO_AUE = "aue";
	
	//音频采样通道数
	public static final String SAMPLE_CHANNEL ="sample_channel";
	//音频采样精度
	public static final String SAMPLE_BIT = "sample_bit";
	
	// 设备mac地址
	public static final String MAC_ADDR = "mac";
	
	// MSC控件版本号
	public static final String MSC_VER = "msc.ver";
	// MSC皮肤名称
	public static final String MSC_SKIN = "msc.skin";
	
	// 服务端返回结果编码
	public static final String KEY_RSE = "rse";

	// 客户端上传参数编码,会话参数
	public static final String KEY_PTE = "pte";
	
	// 采样频度,多长时间去的一次录音回调
	public static final String KEY_RECORD_READ_RATE = "record_read_rate";
	
	/*DTS 2013-06-18 add ISE keys********************begin*/
	public static final String KEY_ISE_SST = "sst";
	public static final String KEY_ISE_CATEGORY = "category";
	/*DTS 2013-06-18 add ISE keys********************end*/

	//中文评测添加Bom头
	public static final String KEY_TEXT_BOM="text_bom";
	//语记调用者APPID
	public static final String KEY_CALLER_APPID="caller.appid";
	
	/*DTS 2014-09-09 add IST keys********************begin*/
	//转写结果等待毫秒数
	public static String IST_RESULT_TIME_LEFT = "wtime";
	//转写会话尝试次数，-1表示无限次
	public static final int VALUE_IST_SESSION_TRY_INFINITY = -1;
	//转写会话尝试次数，默认值，仅在音频源为－1时起作用
	public static final int VALUE_IST_SESSION_TRY_DEFAULT = 1;
	//转写录音默认保存位置
	public static final String VALUE_IST_AUDIO_PATH = Environment.getExternalStorageDirectory().getPath()+"/msc/ist/audio/";
	/*DTS 2014-09-09 add IST keys********************end*/

	// 录音源，设为-1表示外部传送录音数据
	public static final int VALUE_AUDIO_EXTERNAL = -1;
	// 录音源，设为-2表示外部指定音频文件进行识别
	public static final int VALUE_AUDIO_EXTERNALFILE = -2;
	// 录音源，设为-3表示使用AIMIC录音
	public static final int VALUE_AUDIO_AIMIC = -3;
	
	//语法内容<,Aidl调用语记使用
	public static final String GRAMMAR_CONTENT = "grammar_content";

	//词典内容,Aidl调用语记使用
	public static final String LEXICON_CONTENT = "lexicon_content";

	//词典名字,Aidl调用语记使用
	public static final String LEXICON_NAME = "lexicon_name";
	
	//合成音频保存地址, Aidl 调用语记使用
	public static final String TTS_AUDIO_URI = "tts_audio_uri";
	
	//设置是否返回识别音频的url
	public static final String REQUEST_AUDIO_URL = "request_audio_url";
	
	// 是否在主线程回调（语记反馈在主线程回调音频过于频繁会阻塞且导致崩溃）
	public static final String MESSAGE_MAIN_THREAD = "message_main_thread";
	
	// 唤醒相关参数
	public static final String IVW_ENROLL = "enroll";
	public static final String IVW_WAKE = "wakeup";
	public static final String IVW_ONESHOT = "oneshot";

	// 关闭，不允许数据上传及唤醒服务启动时请求查询
	public static final int IVW_MODE_CLOSE = 0;
	// 允许进行数据上传，不允许唤醒服务启动时请求查询
	public static final int IVW_NORMAL_UPDATA = 1;
	// 允许进行数据上传和唤醒服务启动时请求查询
	public static final int IVW_NORMAL_QUERY = 2;
	// 仅在wifi网络下，允许进行数据上传，不允许唤醒服务启动时请求查询
	public static final int IVW_WIFI_UPDATA = 3;
	// 仅在wifi网络下，允许进行数据上传和唤醒服务启动时请求查询
	public static final int IVW_WIFI_QUERY = 4;
	//闭环优化上次查询时间
	public static final String KEY_IVW_QUERY_LASTTIME = "ivw_query_last_time";
	//闭环优化查询时间间隔
	public static final String KEY_IVW_QUERY_PERIOD = "ivw_query_period"; 
	// 闭环优化自动查询资源最短隔间
	public static final int IVW_DEF_QUERY_PERIOD = 1000 * 60 * 60 * 24;
	// 唤醒路数：单路
	public static final int IVW_CHANNEL_SINGLE = 0;
	
	// 唤醒缓存参数
	public static final String IVW_CONFIG_PATH = "ivw_config_path";
	// 配置资源推荐门限值
	public static final String IVW_CONFIG_THRESHOLD = "cfg_threshold";
	// 配置资源临时保存门限值
	public static final String IVW_CONFIG_THRESTMEP = "cfg_threstemp";
	
	/**
	 * 需要合成文本内容（0~1024Byte）。
	 */
	public static final String TEXT = "text";
	// 合成最短缓存时间（ms）
	public static final String KEY_TTS_MIN_AUDIO_LEN = "tts_min_audio_len";
	
	public static final String KEY_TTS_NEXT_AUDIO_PATH = "tts_next_audio_path";
	
	//合成倍速
	public static final String KEY_SPEED_INCREASE = "speed_increase";
	
	public static final String KEY_TTS_PROC_SCALE = "tts_proc_scale";
	
	//合成播放是否在缓存间隔时淡入淡出
	public static final String KEY_TTS_BUFFERING_FADING = "tts_buf_fading";
	
	//是否需要播放音频结束时的静音
	public static final String END_WITH_NULL = "end_with_null";
	
	//合成 info json key: spellinfo
	public static final String JSON_KEY_SPELLINFO = "spell_info";
	
	//合成音频信息
	public static final String KEY_AUDIO_INFO = "audio_info";
	
	//合成 info json key: audio_len
	public static final String JSON_KEY_AUDIOLEN = "audio_len";
	
	public static final String RECORD_FORCE_STOP = "record_force_stop";
	
	// 界面是否显示不带错误码的简化文字
	// 默认为false，含错误码；当应用设置为true时，不含错误码。
	public static final String VIEW_TIPS_PLAIN = "view_tips_plain";
	
	// 客户端msc版本
	public static final String VER_MSC = "ver_msc";
	// 识别引擎版本
	public static final String VER_ASR = "ver_asr";
	// 合成引擎版本
	public static final String VER_TTS = "ver_tts";
	// 唤醒引擎版本
	public static final String VER_IVW = "ver_ivw";
	// msc唤醒筛选区间
	public static final String IVW_NETVAL = "ivw_netval";
	
	public static final String KEY_VAL_SEP = "=";
	public static final String KEY_SEP = ",";
	public static final String VAL_SEP = ";";
	
	public static final String BOS_DISPOSE = "bos_dispose";
	
	public static final String AIMIC_INIT_PARAM = "aimic_init_param";
	public static final String AIMIC_SSB_PARAM_PREFIX = "aimic_ssb_";
	public static final String AIMIC_ON_PARAM_PREFIX = "aimic_on_";
	
	public static final String AIMIC_ALSA_SAMPLE_RATE = "alsa_rate";
	public static final String AIMIC_ALSA_CARD = "alsa_card";
	
	public static final String AIMIC_CHANNEL = AIMIC_ON_PARAM_PREFIX+"channel";
	public static final String AIMIC_VERSION = AIMIC_ON_PARAM_PREFIX+"version";

	public static final String ACTIVITY_NAME = "act_name";
	
	public static enum VadStatus{
		VAD_LOOKING	//还没有检测到音频的前端点
		, VAD_INSPEECH //已经检测到了音频前端点，正在进行正常的音频处理
		, undefined_2	//未定义的状态
		, VAD_EOS //检测到音频的后端点，后继的音频会被MSC忽略
		, VAD_TIMEOUT //超时
		, VAD_ERROR //错误
	}
	
	/**************************业务类型开始********************************/
	// 听写
	public static final String SUB_IAT = "iat";
	// 识别
	public static final String SUB_ASR = "asr";
	// 合成
	public static final String SUB_TTS = "tts";
	// 声纹
	public static final String SUB_IVP = "ivp";
	// 评测
	public static final String SUB_SEE = "ise";
	// 转写
	public static final String SUB_IST = "ist";
	// 身份验证
	public static final String SUB_MFV = "mfv";
	// 多重身份认证之人脸
	public static final String SUB_IFR = "ifr";
	// 数据上传
	public static final String SUB_UUP = "uup";
	// 语义
	public static final String SUB_SCH = "sch";
	// 校验
	public static final String SUB_AUTH = "auth";
	// 手写
	public static final String SUB_HCR = "hcr";
	//唤醒
	public static final String SUB_IVW = "ivw";
	/** 听写语义，灵犀云稽核定义需要，参数名，见{@link #KEY_UNDERSTAND} */
	public static final String SUB_IATSCH = "iat_sch";
	/**************************业务类型结束********************************/

	public static final String KEY_LXY_DATA_COLLECT_ENABLE = "lxy_tp_dc";
	public final static String VAL_FALSE = "false";
	
	// 关键字映射关系，eos后端点的设置需要注意，映射成两个值
	public static final String[][] MSC_MAP_KEYS = 
	{
		// 服务器地址
		{"surl", SERVER_URL},
		// 是否寻找最佳服务器
		{"besturl_search", "search_best_url"},
		{"bsts", "search_best_url"},
		// 是否进行语义识别
		{SpeechConstant.ASR_SCH, SUB_SCH},
		// 服务端无结果，是否返回10118错误,当服务端无结果返回，是否发生10118错误
		{SpeechConstant.ASR_NOMATCH_ERROR, "asr_nme"},		
		// 是否有标点符号
		{SpeechConstant.ASR_PTT, "ptt"},
		// 是否有标点符号,服务端返回结果格式
		{SpeechConstant.RESULT_TYPE, "rst"},
		// 结果等级（详细程度），暂时只有评测用到
		{SpeechConstant.RESULT_LEVEL, "rst_level"},
		// 前端点静音超时,VAD前端点超时
		{SpeechConstant.VAD_BOS,"vad_timeout"},
		{"bos","vad_timeout"},
		// 后端点静音超时,VAD后端点超时,eos表示服务端
		{SpeechConstant.VAD_EOS,"vad_speech_tail","eos"},
		{"eos","vad_speech_tail","eos"},
		// 录音保存路径,识别录音保存路径，默认为null，不保存
		{SpeechConstant.ASR_AUDIO_PATH, "aap"},
		// TTS音频缓冲时间,合成音频缓冲时间，缓冲多少ms音频之后开始播放，默认为第一句话
		{SpeechConstant.TTS_BUFFER_TIME, "tbt"},
		// TTS音频保存路径,合成音频保存路径，默认为null，不保存
		{SpeechConstant.TTS_AUDIO_PATH, "tap"},
		// 业务类型
		{SpeechConstant.SUBJECT, "sub"},
		// 数据类型
		{SpeechConstant.DATA_TYPE, "dtt"},
		// 句子级多候选结果，最大等于5
		{SpeechConstant.ASR_NBEST, "nbest"},
		// 词级多候选结果，最大等于5
		{SpeechConstant.ASR_WBEST, "wbest"},
		// 是否结果动态修正
		{SpeechConstant.ASR_DWA, "dwa"},
		// 发音人，默认xiaoyan
		{SpeechConstant.VOICE_NAME, "vcn"},
		// 背景音乐
		{SpeechConstant.BACKGROUND_SOUND, "bgs"},
		// 文本编码
		{SpeechConstant.TEXT_ENCODING, "tte"},
		// 唤醒闭环优化上传数据
		{SpeechConstant.IVW_NET_MODE, "ivwnet_mode"},
	};
}
